#pragma once
#include "component.h"
#include <string>
#include "raylib.h"
#include "transform.h"

namespace ant::components::graphical {
	struct sprite_component : public ant::core::component {
		sprite_component() {}
		sprite_component(const std::string& str, int layer = 0, ant::core::transform<> reposition = {{0,0},0}, ant::core::Vec2<> scale = {1,1});
		std::string name() override {return "sprite_component";}
		void render() override;
	private:
		Texture2D current_texture;
		ant::core::transform<> transform;
		ant::core::Vec2<> m_scale;
		int m_layer;
	};
}